## GUN SHOOT
# AS AT ANCHORED EYES of shooting player
# Used for ALL guns

##getting gun stats
execute store result score gun_max_ammo gbg.temp run data get entity @s SelectedItem.tag.gun_max_ammo
execute store result score gun_ammo gbg.temp run data get entity @s SelectedItem.tag.gun_ammo
execute store result score gun_damage gbg.temp run data get entity @s SelectedItem.tag.gun_damage
execute store result score gun_range gbg.temp run data get entity @s SelectedItem.tag.gun_range
execute store result score gun_fire_rate gbg.temp run data get entity @s SelectedItem.tag.gun_fire_rate

#stopping funciton if out of ammo
execute if score gun_ammo gbg.temp matches ..0 unless score gun_max_ammo gbg.temp matches 0 run return 0

## Playing Sound
data modify storage gbg:sounds sound set from entity @s SelectedItem.tag.gun_shoot_sound
function gbg:gun/shoot_sound with storage gbg:sounds

## Updating Description and Tags
# lowering gun current ammo
scoreboard players remove gun_ammo gbg.temp 1
# calculaitons for new "damage" (for the durability bar)
function gbg:calculate_durability
execute if score new_damage gbg.temp matches ..1 run scoreboard players set new_damage gbg.temp 1
# applying new damage and ammo tags
data modify storage gbg:generic tag set value {}
execute store result storage gbg:generic tag.Damage int 1 run scoreboard players get new_damage gbg.temp
execute store result storage gbg:generic tag.gun_ammo int 1 run scoreboard players get gun_ammo gbg.temp
execute unless score gun_max_ammo gbg.temp matches ..0 run item modify entity @s weapon.mainhand gbg:general/change_damage
execute unless score gun_max_ammo gbg.temp matches ..0 run item modify entity @s weapon.mainhand gbg:general/change_ammo
# calculating gun damage for explosive weapons
execute store result score gun_damage_type gbg.temp run data get entity @s SelectedItem.tag.gun_damage_type
execute if score gun_damage_type gbg.temp matches 2..3 run function gbg:calculate_damage
# building lore
item modify entity @s weapon.mainhand gbg:general/remove
execute unless score gun_max_ammo gbg.temp matches ..0 run item modify entity @s weapon.mainhand gbg:general/ammo
execute if score gun_max_ammo gbg.temp matches ..0 run item modify entity @s weapon.mainhand gbg:general/infinite_ammo
item modify entity @s weapon.mainhand gbg:general/gun_damage
item modify entity @s weapon.mainhand gbg:general/gun_range
item modify entity @s weapon.mainhand gbg:general/fire_rate


## Setting Recoil
execute store result score recoil_strength gbg.temp run data get entity @s SelectedItem.tag.recoil_strength
execute if score recoil_strength gbg.temp matches 1..3 run scoreboard players set @s gbg.recoil_duration 5
execute if score recoil_strength gbg.temp matches 1 run scoreboard players set @s gbg.recoil_type 1
execute if score recoil_strength gbg.temp matches 2 run scoreboard players set @s gbg.recoil_type 2
execute if score recoil_strength gbg.temp matches 3 run scoreboard players set @s gbg.recoil_type 3


## Shooting Projectile
#all the cute preliminary stuff
execute store result score gun_damage gbg.temp run data get entity @s SelectedItem.tag.gun_damage
tag @s add gun_immune
scoreboard players operation @s gbg.cooldown = gun_fire_rate gbg.temp
execute store result storage gbg:macro input.source int 1 run scoreboard players get @s gbg.id
execute store result storage gbg:macro input.damage int 1 run scoreboard players get gun_damage gbg.temp
data modify storage gbg:macro input.gun_name set from entity @s SelectedItem.tag.display.Name
scoreboard players operation gun_range gbg.temp *= 10 number
#running the right raycast
execute store result score gun_projectile_type gbg.temp run data get entity @s SelectedItem.tag.gun_projectile_type
execute if score gun_projectile_type gbg.temp matches 1 run function gbg:gun/projectile/bullet
execute if score gun_projectile_type gbg.temp matches 2 run function gbg:gun/projectile/rocket
execute if score gun_projectile_type gbg.temp matches 3 run function gbg:gun/projectile/fire
execute if score gun_projectile_type gbg.temp matches 4 run function gbg:gun/projectile/blaze_fire
execute if score gun_projectile_type gbg.temp matches 5 run function gbg:gun/projectile/laser
execute if score gun_projectile_type gbg.temp matches 6 run function gbg:gun/projectile/large_laser
execute if score gun_projectile_type gbg.temp matches 7 run function gbg:gun/projectile/green
execute if score gun_projectile_type gbg.temp matches 8 run function gbg:gun/projectile/blue
execute if score gun_projectile_type gbg.temp matches 9 run function gbg:gun/projectile/pink
execute if score gun_projectile_type gbg.temp matches 10 run function gbg:gun/projectile/red

## Shooting Additional Projectiles
#only does this if the fire rate = 1
execute if score gun_fire_rate gbg.temp matches 1 unless score @s gbg.burst_duration matches 1.. run scoreboard players set @s gbg.burst_duration 4



